/* savelev.c		 Larn is copyrighted 1986 by Noah Morgan. */
#include "header.h"
extern struct cel huge *cell;

unsigned char far *normalise(unsigned char far *);

/*
 *	routine to save the present level into storage
 */
savelevel()
	{
	struct cel *pcel;
	char *pitem,*pknow,*pmitem;
	short *phitp,*piarg;
	struct cel *pecel;
	pcel = (struct cel *)normalise((unsigned char far *)(&cell[level*MAXX*MAXY]));	/* pointer to this level's cells */
	pecel = pcel + MAXX*MAXY;	/* pointer to past end of this level's cells */
	pitem=item[0]; piarg=iarg[0]; pknow=know[0]; pmitem=mitem[0]; phitp=hitp[0];
	while (pcel < pecel)
		{
		pcel->mitem  = *pmitem++;
		pcel->hitp   = *phitp++;
		pcel->item   = *pitem++;
		pcel->know   = *pknow++;
		pcel++->iarg = *piarg++;
		}
	}

/*
 *	routine to restore a level from storage
 */
getlevel()
	{
	struct cel *pcel;
	char *pitem,*pknow,*pmitem;
	short *phitp,*piarg;
	struct cel *pecel;
	pcel = (struct cel *)normalise((unsigned char far *)(&cell[level*MAXX*MAXY]));	/* pointer to this level's cells */
	pecel = pcel + MAXX*MAXY;	/* pointer to past end of this level's cells */
	pitem=item[0]; piarg=iarg[0]; pknow=know[0]; pmitem=mitem[0]; phitp=hitp[0];
	while (pcel < pecel)
		{
		*pmitem++ = pcel->mitem;
		*phitp++ = pcel->hitp;
		*pitem++ = pcel->item;
		*pknow++ = pcel->know;
		*piarg++ = pcel++->iarg;
		}
	}
				   
#define PTR_SEG(x) (*(((unsigned int *)&x)+1))
#define PTR_OFF(x) (*((unsigned int *)&x))

unsigned char far *normalise (x)
unsigned char far *x;
   {
	PTR_SEG(x)	+= PTR_OFF(x) >> 4;
	PTR_OFF(x)	&= 0XF;
	return x;
   }
